'''A Class for D&D 3.5 Mod

To do:
    Finish spells
    Play Test Eveything'''

import es, dnds, popuplib, math, gamethread, playerlib, random
from dnds import dnds

SpellCommands = ['cure', 'faith', 'bear', 'shatter', 'animate', 'heal', 'flame', 'masscure', 'res', 'storm', 'massheal']

def load():
    dnds.addClass('Cleric', dnds.SMGs+dnds.Grenades+dnds.Pistols+['knife','galil','famas', 'm3'])

    for command in SpellCommands:
        if not es.exists('saycommand', command):
            es.regsaycmd(command, 'dnds/SubScripts/Cleric/%s'%command)
        if not es.exists('clientcommand', command):
            es.regclientcmd(command, 'dnds/SubScripts/Cleric/%s'%command)
    
    dnds.Commands['cast']['Classes'].append('Cleric')
    
    clericcast = popuplib.create('Clericcast')
    clericcast.addline('-{ Cleric Cast Menu }-')
    clericcast.addline('-> 1. Cure Wounds')
    clericcast.addline('-> 2. Shield of Faith')
    clericcast.addline('-> 3. Bear\'s Endurance')
    clericcast.addline('-> 4. Shatter')
    clericcast.addline('-> 5. Animate Dead')
    clericcast.addline('-> 6. Heal')
    clericcast.addline('-> 7. Flame Strike')
    clericcast.addline('-> 8. Mass Cure')
    clericcast.addline('-> 9. High Level Spells')
    clericcast.addline('0. Exit')
    clericcast.prepuser = clericCastPrep
    clericcast.menuselect = clericCast

    clericcast2 = popuplib.create('ClericcastHigh')
    clericcast2.addline('-{ Cleric High Lvl Castings }-')
    clericcast2.addline('-> 1. Ressurection')
    clericcast2.addline('-> 2. Fire Storm')
    clericcast2.addline('-> 3. Mass Heal')
    clericcast2.addline('-> 9. Low Level Spells')
    clericcast2.addline('0. Exit')
    clericcast2.submenu(9, 'Clericcast')
    clericcast2.prepuser = clericCastPrepHigh
    clericcast2.menuselect = clericCastHigh
    
    clericinfo = popuplib.create('clericinformation')
    clericinfo.addline('-{ D&D CS:S - Cleric }-')
    clericinfo.addline(' Weapons: SMGs, Pistols, M3, Galil, and Famas')
    clericinfo.addline(' Enter \'cast\' into chat for a casting menu')
    clericinfo.addline(' Or enter the (keyword) listed to directly cast a spell')
    clericinfo.addline('-> 1. Low Level Spells')
    clericinfo.addline('-> 2. Meduim Level Spells')
    clericinfo.addline('-> 3. High Level Spells')
    clericinfo.addline('-> 7. Play as a Cleric')
    clericinfo.addline('-> 8. Back')
    clericinfo.addline('0. Exit')
    clericinfo.submenu(1, 'cleric spinfo 1')
    clericinfo.submenu(2, 'cleric spinfo 2')
    clericinfo.submenu(3, 'cleric spinfo 3')
    clericinfo.submenu(8, 'classinfo 1')
    clericinfo.menuselect = clericMenuSelect
    dnds.addClassInformation('Cleric', 'clericinformation')
    
    spinfo1 = popuplib.create('cleric spinfo 1')
    spinfo1.addline('-{ Cleric - Low - Spells }-')
    spinfo1.addline(' Cure Wounds (lvl 1)')
    spinfo1.addline('  - Heal selected ally (cure)')
    spinfo1.addline(' Shield of Faith (lvl 1)')
    spinfo1.addline('  - Selected ally gains DR (faith)')
    spinfo1.addline(' Bear\'s Endurance (lvl 3)')
    spinfo1.addline('  - Selected ally gains extra temp. health (bear)')
    spinfo1.addline(' Shatter (lvl 5)')
    spinfo1.addline('  - Destory target\'s active weapon (shatter)')
    spinfo1.addline('-> 8. Back')
    spinfo1.addline('0. Exit')
    spinfo1.submenu(8, 'clericinformation')
    
    spinfo2 = popuplib.create('cleric spinfo 2')
    spinfo2.addline('-{ Cleric - Medium - Spells }-')
    spinfo2.addline(' Animate Dead (lvl 7)')
    spinfo2.addline('  - Raise selected ally as a skeleton (500$) (animate)')
    spinfo2.addline(' Heal (lvl 9)')
    spinfo2.addline('  - Greatly heal selected ally (heal)')
    spinfo2.addline(' Flame Strike (lvl 11)')
    spinfo2.addline('  - Damage and burn your target (flame)')
    spinfo2.addline(' Cure Wounds Mass (lvl 13)')
    spinfo2.addline('  - Heal all allies (masscure)')
    spinfo2.addline('-> 8. Back')
    spinfo2.addline('0. Exit')
    spinfo2.submenu(8, 'clericinformation')
    
    spinfo3 = popuplib.create('cleric spinfo 3')
    spinfo3.addline('-{ Cleric - High - Spells }-')
    spinfo3.addline('  Ressurection (lvl 15)')
    spinfo3.addline('  - Restore selected ally to life (res)')
    spinfo3.addline('  Fire Storm (lvl 17)')
    spinfo3.addline('  - Strike your target and all those around them with damage and fire (storm)')
    spinfo3.addline('  Mass Heal (lvl 19)')
    spinfo3.addline('  - Restore all teammates for 60 HP (massheal)')
    spinfo3.addline('-> 8. Back')
    spinfo3.addline('0. Exit')
    spinfo3.submenu(8, 'clericinformation')
    
    dnds.addRace('Zombie', monsterRace=True, bpRequired=0, bonusWeapons=['knife'], menu=False)
    dnds.addRace('Skeleton', monsterRace=True, bpRequired=0, bonusWeapons=['knife', 'p228'], menu=False)

def clericMenuSelect(userid, choice, popupid):
    if choice == 7:
        Key = dnds.getPlayer(userid)
        Key['delayed']['class'] = 'Cleric'
        es.tell(userid, '#multi', 'You will be a Cleric once the round ends')

def player_spawn(ev):
    userid = int(ev['userid'])
    Key = dnds.getPlayer(userid)
    if dnds.isClass(userid, 'Cleric'):
        level = dnds.getLevel(userid, 'Cleric')
        Key['spells'][1] += level
        if level >= 7:
            Key['spells'][2] += level/3
        if level >= 13:
            Key['spells'][3] += level/5
    if dnds.isRace(userid, 'Zombie'):
        dnds.Speed(userid, -.3)
        es.server.queuecmd('est_setplayercolor %s 0 0 0 255 1'%userid)
        Key['damage reduction'] = .5
        dnds.Health(userid, 400)
    if dnds.isRace(userid, 'Skeleton'):
        dnds.Speed(userid, -.1)
        es.server.queuecmd('est_setplayercolor %s 0 0 0 255 1'%userid)
        es.server.queuecmd('es_xgive %s weapon_p228'%userid)
        dnds.Health(userid, 15)

def cure():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 1, 1, 'Cleric', ignore=['Ranger', 'Cleric']) or dnds.checkSpell(userid, 1, 1, 8, 'Ranger', ignore=['Cleric', 'Ranger']):
        dnds.playerMenu(userid, cureSelect, 'Select a player to cast Cure Wounds on', es.getplayerteam(userid), distance=360, extra='health')

def cureSelect(userid, choice, popupid):
    if dnds.checkSpell(userid, 1, 1, 1, 'Cleric', ignore=['Cleric', 'Ranger']) or dnds.checkSpell(userid, 1, 1, 8, 'Ranger', ignore=['Cleric', 'Ranger']):
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(choice)
        if math.sqrt(math.pow(x1-x2, 2) + math.pow(y1-y2, 2) + math.pow(z1-z2, 2)) <= 360:
            dnds.Heal(choice, 15)
            if choice != userid:
                dnds.giveXp(userid, 10, 'helping an ally')
                es.tell(choice, '#multi', 'You have been healed by %s for 15 health'%es.getplayername(userid))
            es.tell(userid, '#multi', 'You have healed %s for 15 health'%es.getplayername(choice))
            dnds.spellDelay(userid, 3)
            Key = dnds.getPlayer(userid)
            Key['spells'][1] -= 1
        else:
            es.tell(userid, '#multi', '%s is now too far away to cast Cure Wounds on.'%es.getplayername(choice))

def faith():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 1, 1, 'Cleric'):
        dnds.playerMenu(userid, faithSelect, 'Select a player to cast Shield of Faith on', es.getplayerteam(userid), distance=360, buff='dr')

def faithSelect(userid, choice, popupid):
    if dnds.checkSpell(userid, 1, 1, 1, 'Cleric'):
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(choice)
        if math.sqrt(math.pow(x1-x2, 2) + math.pow(y1-y2, 2) + math.pow(z1-z2, 2)) <= 360:
            Key = dnds.getPlayer(choice)
            Key['damage reduction'] += .2
            dnds.Delayed(choice, 15, faithRemove, (choice))
            if choice != userid:
                dnds.giveXp(userid, 10, 'helping an ally')
                es.tell(choice, '#multi', '%s granted you damage reduction with their Shield of Faith for the next 15 seconds'%es.getplayername(userid))
            es.tell(userid, '#multi', 'You have cast Shield of Faith on %s for 15 seconds'%es.getplayername(choice))
            dnds.spellDelay(userid, 6)
            dnds.Buffs(choice, 'dr', 15)
            Key = dnds.getPlayer(userid)
            Key['spells'][1] -= 1
        else:
            es.tell(userid, '#multi', '%s is now too far away to cast Shield of Faith on.'%es.getplayername(choice))

def faithRemove(userid):
    Key = dnds.getPlayer(userid)
    Key['damage reduction'] -= .2
    es.tell(userid, '#multi', 'Your Shield of Faith bonus has worn off')

def bear():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 3, 3, 'Cleric'):
        dnds.playerMenu(userid, bearSelect, 'Select a player to cast Bear\'s Endurance on', es.getplayerteam(userid), distance=360, buff='health')

def bearSelect(userid, choice, popupid):
    if dnds.checkSpell(userid, 1, 3, 3, 'Cleric'):
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(choice)
        if math.sqrt(math.pow(x1-x2, 2) + math.pow(y1-y2, 2) + math.pow(z1-z2, 2)) <= 360:
            dnds.TempHealth(choice, 40, 20)
            if choice != userid:
                dnds.giveXp(userid, 15, 'helping an ally')
                es.tell(choice, '#multi', '%s granted you bonus health with their Bear\'s Endurance for the next 20 seconds'%es.getplayername(userid))
            es.tell(userid, '#multi', 'You have cast Bear\'s Endurance on %s for 20 seconds'%es.getplayername(choice))
            dnds.Delayed(choice, 20, es.tell, (choice, '#multi', 'Your bonus health from Bear\'s Endurance has worn off.'))
            dnds.spellDelay(userid, 6)
            dnds.Buffs(choice, 'health', 20)
            Key = dnds.getPlayer(userid)
            Key['spells'][1] -= 2
        else:
            es.tell(userid, '#multi', '%s is now too far away to cast Bear\'s Endurance on.'%es.getplayername(choice))

def shatter():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 1, 3, 5, 'Cleric'):
        dnds.spellDelay(userid, .1)
        es.ServerVar('_dnd_temp%s'%userid).set(0)
        es.server.queuecmd('est_getviewplayer %s _dnd_temp%s'%(userid, userid))
        gamethread.delayed(.1, shatterRun, (userid))

def shatterRun(userid):
    target = int(es.ServerVar('_dnd_temp%s'%userid))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 720:
            weapon = playerlib.getPlayer(target).get('weapon')
            if weapon:
                weapon = weapon.replace('weapon_', '')
                if weapon in dnds.Weapons and weapon != 'knife':
                    es.server.queuecmd('est_RemoveWeapon %s %s'%(target, weapon))
                    es.tell(target, '#multi', 'Your weapon has been shattered by %s'%es.getplayername(userid))
                    es.tell(userid, '#multi', 'You have shattered %s\'s weapon'%es.getplayername(target))
                    dnds.spellDelay(userid, 4)
                    Key = dnds.getPlayer(userid)
                    Key['spells'][1] -= 3

def animate():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 2, 2, 7, 'Cleric', ignore=['Wizard', 'Warlock']) or dnds.checkSpell(userid, 2, 2, 9, 'Wizard', ignore=['Cleric', 'Warlock']) or dnds.checkSpell(userid, 1, 0, 9, 'Warlock', ignore=['Cleric', 'Wizard']):
        if es.getplayerprop(userid,'CCSPlayer.m_iAccount') >= 500:
            dnds.playerMenu(userid, animateSelect, 'Select a dead ally to Animate', dead=1, team=es.getplayerteam(userid), distance=360, extra='not undead')
        else:
            es.tell(userid, '#multi', 'You need 500$ to cast animate dead!')

def animateCleric(userid, target):
    if dnds.checkSpell(userid, 2, 2, 7, 'Cleric'):
        Key = dnds.getPlayer(userid)
        Key['spells'][2] -= 2
        dnds.spellDelay(userid, 6)
        dnds.Cash(userid, -500)
        Key = dnds.getPlayer(target)
        ID = dnds.Bank(target)
        Class = ID['class']
        prestige = ID['prestige']
        race = ID['race']
        Key['undead'] = [race, Class, prestige]
        Key['delayed']['class'] = Class
        Key['delayed']['prestige'] = prestige
        Key['delayed']['race'] = race
        ID['class'] = None
        ID['prestige'] = None
        ID['race'] = 'Skeleton'
        x,y,z = Key['death location']
        es.server.queuecmd('est_Spawn %s 1'%target)
        es.server.queuecmd('es_xsetpos %s %s %s %s'%(target, x, y, z))
        es.tell(target, '#multi', 'You have been raised has a Skeleton by %s'%es.getplayername(userid))

def animateWizard(userid, target):
    if dnds.checkSpell(userid, 2, 2, 9, 'Wizard'):
        Key = dnds.getPlayer(userid)
        Key['spells'][2] -= 2
        dnds.spellDelay(userid, 6)
        dnds.Cash(userid, -500)
        Key = dnds.getPlayer(target)
        ID = dnds.Bank(target)
        Class = ID['class']
        prestige = ID['prestige']
        race = ID['race']
        Key['undead'] = [race, Class, prestige]
        Key['delayed']['class'] = Class
        Key['delayed']['prestige'] = prestige
        Key['delayed']['race'] = race
        ID['class'] = None
        ID['prestige'] = None
        ID['race'] = 'Zombie'
        x,y,z = Key['death location']
        es.server.queuecmd('est_Spawn %s 1'%target)
        es.server.queuecmd('es_xsetpos %s %s %s %s'%(target, x, y, z))
        es.tell(target, '#multi', 'You have been raised has a Zombie by %s'%es.getplayername(userid))

def animateWarlock(userid, target):
    if dnds.checkSpell(userid, 1, 0, 9, 'Warlock'):
        Key = dnds.getPlayer(userid)
        dnds.spellDelay(userid, 10)
        dnds.Cash(userid, -500)
        Key = dnds.getPlayer(target)
        ID = dnds.Bank(target)
        Class = ID['class']
        prestige = ID['prestige']
        race = ID['race']
        Key['undead'] = [race, Class, prestige]
        Key['delayed']['class'] = Class
        Key['delayed']['prestige'] = prestige
        Key['delayed']['race'] = race
        ID['class'] = None
        ID['prestige'] = None
        ID['race'] = 'Zombie'
        x,y,z = Key['death location']
        es.server.queuecmd('est_Spawn %s 1'%target)
        es.server.queuecmd('es_xsetpos %s %s %s %s'%(target, x, y, z))
        es.tell(target, '#multi', 'You have been raised has a Zombie by %s'%es.getplayername(userid))

def animateSelect(userid, choice, popupid):
    if es.getplayerprop(userid,'CCSPlayer.m_iAccount') >= 500:
        ID = dnds.Bank(userid)
        if ID['class'] == 'Cleric':
            animateCleric(userid, choice)
        elif ID['class'] == 'Wizard':
            animateWizard(userid, choice)
        elif ID['class'] == 'Warlock':
            animateWarlock(userid, choice)
        else:
            es.tell(userid, '#multi', 'Let Jeff know you saw this text... Yea')
    else:
        es.tell(userid, '#multi', 'You need 500$ to cast animate dead!')

def heal():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 2, 2, 9, 'Cleric'):
        dnds.playerMenu(userid, healSelect, 'Select a player to cast Heal on', es.getplayerteam(userid), distance=360, extra='health')

def healSelect(userid, choice, popupid):
    if dnds.checkSpell(userid, 2, 2, 9, 'Cleric'):
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(choice)
        if math.sqrt(math.pow(x1-x2, 2) + math.pow(y1-y2, 2) + math.pow(z1-z2, 2)) <= 360:
            dnds.Heal(choice, 60)
            if choice != userid:
                dnds.giveXp(userid, 20, 'helping an ally')
                es.tell(choice, '#multi', 'You have been healed by %s for 60 health'%es.getplayername(userid))
            es.tell(userid, '#multi', 'You have healed %s for 60 health'%es.getplayername(choice))
            dnds.spellDelay(userid, 6)
            Key = dnds.getPlayer(userid)
            Key['spells'][2] -= 2
        else:
            es.tell(userid, '#multi', '%s is now too far away to cast Heal on.'%es.getplayername(choice))

def flame():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 2, 2, 11, 'Cleric'):
        dnds.spellDelay(userid, .1)
        es.ServerVar('_dnd_temp%s'%userid).set(0)
        es.server.queuecmd('est_getviewplayer %s _dnd_temp%s'%(userid, userid))
        gamethread.delayed(.1, flameRun, (userid))

def flameRun(userid):
    target = int(es.ServerVar('_dnd_temp%s'%userid))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 1500:
            if not dnds.spellResistance(target, dnds.getLevel(userid, 'Cleric')):
                dnds.Damage(target, userid, random.randrange(30, 90, 10))
                es.server.queuecmd('est_Burn %s 5'%target)
                es.tell(target, '#multi', 'You have been struck by a flame strike')
                es.tell(userid, '#multi', 'You have struck %s with a flame strike'%es.getplayername(target))
            else:
                es.tell(userid, '#multi', '%s has resisted your flame strike'%es.getplayername(target))
            dnds.spellDelay(userid, 4)
            Key = dnds.getPlayer(userid)
            Key['spells'][2] -= 2

def masscure():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 2, 3, 13, 'Cleric'):
        dnds.spellDelay(userid, 6)
        Key = dnds.getPlayer(userid)
        Key['spells'][2] -= 3
        es.tell(userid, '#multi', 'You have healed your entire team some.')
        for player in es.getUseridList():
            if es.getplayerteam(userid) == es.getplayerteam(player):
                if not es.getplayerprop(player, 'CBasePlayer.pl.deadflag'):
                    if userid != player:
                        es.tell(player, '#multi', 'You have been healed by %s'%es.getplayername(userid))
                    dnds.Heal(player, 30)

def res():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 3, 3, 15, 'Cleric'):
        dnds.playerMenu(userid, resSelect, 'Select a dead ally to Ressurect', dead=1, team=es.getplayerteam(userid), distance=360, extra='not undead')

def resSelect(userid, choice, popupid):
    if dnds.checkSpell(userid, 3, 3, 15, 'Cleric'):
        dnds.spellDelay(userid, 8)
        Key = dnds.getPlayer(userid)
        Key['spells'][3] -= 3
        Key = dnds.getPlayer(choice)
        es.tell(userid, '#multi', 'You have restored %s to life.'%es.getplayername(choice))
        es.tell(choice, '#multi', '%s has restored you to life.'%es.getplayername(userid))
        x,y,z = Key['death location']
        es.server.queuecmd('est_Spawn %s 1'%choice)
        es.server.queuecmd('es_xsetpos %s %s %s %s'%(choice, x, y, z))

def storm():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 3, 2, 17, 'Cleric'):
        dnds.spellDelay(userid, .1)
        es.ServerVar('_dnd_temp%s'%userid).set(0)
        es.server.queuecmd('est_getviewplayer %s _dnd_temp%s'%(userid, userid))
        gamethread.delayed(.1, stormRun, (userid))

def stormRun(userid):
    target = int(es.ServerVar('_dnd_temp%s'%userid))
    if target:
        x1,y1,z1 = es.getplayerlocation(userid)
        x2,y2,z2 = es.getplayerlocation(target)
        if math.sqrt(math.pow(x1-x2,2)+math.pow(y1-y2,2)+math.pow(z1-z2,2)) <= 2400:
            for player in es.getUseridList():
                if not es.getplayerprop(player, "CBasePlayer.pl.deadflag"):
                    if es.getplayerteam(player) != es.getplayerteam(userid):
                        x3,y3,z3 = es.getplayerlocation(player)
                        if math.sqrt(math.pow(x3-x2,2)+math.pow(y3-y2,2)+math.pow(z3-z2,2)) <= 360:
                            dnds.BeamTop(player, 1, 255, 0, 0)
                            if not dnds.spellResistance(player, dnds.getLevel(userid, 'Cleric')):
                                if target != player:
                                    dnds.Beam3(target, player, 1, 255, 0, 0)
                                dnds.Damage(player, userid, random.randrange(30, 90, 10))
                                es.tell(target, '#multi', 'You have been caught in a fire storm!')
                                es.tell(userid, '#multi', 'You have hit %s with your fire storm'%es.getplayername(player))
                                if not random.randrange(2):
                                    es.server.queuecmd('est_Burn %s %s'%(player, random.randint(6, 12)))
            dnds.spellDelay(userid, 6)
            Key = dnds.getPlayer(userid)
            Key['spells'][1] -= 3

def massheal():
    userid = es.getcmduserid()
    if dnds.checkSpell(userid, 3, 2, 19, 'Cleric'):
        dnds.spellDelay(userid, 6)
        Key = dnds.getPlayer(userid)
        Key['spells'][2] -= 3
        es.tell(userid, '#multi', 'You have restored your entire team\'s health.')
        for player in es.getUseridList():
            if es.getplayerteam(userid) == es.getplayerteam(player):
                if not es.getplayerprop(x, 'CBasePlayer.pl.deadflag'):
                    if userid != player:
                        es.tell(player, '#multi', 'You have been healed by %s'%userid)
                    dnds.Heal(player, 60)

def clericCast(userid, choice, popupid):
    if choice == 1:
        es.cexec(userid, 'cure')
    elif choice == 2:
        es.cexec(userid, 'faith')
    elif choice == 3:
        es.cexec(userid, 'bear')
    elif choice == 4:
        es.cexec(userid, 'shatter')
    elif choice == 5:
        es.cexec(userid, 'animate')
    elif choice == 6:
        es.cexec(userid, 'heal')
    elif choice == 7:
        es.cexec(userid, 'flame')
    elif choice == 8:
        es.cexec(userid, 'masscure')
    elif choice == 9 and  dnds.getLevel(userid, 'Cleric') >= 15:
        popuplib.find('ClericcastHigh').send(userid)
    elif choice == 9 and dnds.Bank(userid)['prestige']:
        dnds.popupSend('%scast'%dnds.Bank(userid)['prestige'], userid)

def clericCastPrep(userid, popupid):
    popup = popuplib.find('Clericcast')
    Key = dnds.getPlayer(userid)
    ID = dnds.Bank(userid)
    prestige = ID['prestige']
    level = dnds.getLevel(userid, 'Cleric')
    popup.modline(1, '-{ Cleric Cast - %sL - %sM }-'%(Key['spells'][1], Key['spells'][2]))
    if Key['spells'][1] < 1:
        popup.modline(2, ' Cure Wounds')
        popup.modline(3, ' Shield of Faith')
    else:
        popup.modline(2, '-> 1. Cure Wounds 1L')
        popup.modline(3, '-> 2. Shield of Faith 1L')
    if level < 3:
        popup.modline(4, '')
    else:
        if Key['spells'][1] < 2:
            popup.modline(4, ' Bear\'s Endurance')
        else:
            popup.modline(4, '-> 3. Bear\'s Endurance 2L')
    if level < 5:
        popup.modline(5, '')
    else:
        if Key['spells'][1] < 3:
            popup.modline(5, ' Shatter')
        else:
            popup.modline(5, '-> 4. Shatter 3L')
    if level < 7:
        popup.modline(6, '')
    else:
        if Key['spells'][2] < 2:
            popup.modline(6, ' Animate Dead')        
        else:
            popup.modline(6, '-> 5. Animate Dead 2M')
    if level < 9:
        popup.modline(7, '')
    else:
        if Key['spells'][2] < 2:
            popup.modline(7, ' Heal')
        else:
            popup.modline(7, '-> 6. Heal 2M')
    if level < 11:
        popup.modline(8, '')
    else:
        if Key['spells'][2] < 2:
            popup.modline(8, ' Flame Strike')
        else:
            popup.modline(8, '-> 7. Flame Strike 2M')
    if level < 13:
        popup.modline(9, '')
    else:
        if Key['spells'][2] < 3:
            popup.modline(9, ' Mass Cure')        
        else:
            popup.modline(9, '-> 8. Mass Cure 3M')
    if level < 15:
        popup.modline(10, '')
    else:
        popup.modline(10, '-> 9. High Level Spells')
    if prestige:
        popup.modline(10, '-> 9. Prestige Spells')

def clericCastHigh(userid, choice, popupid):
    if choice == 1:
        es.cexec(userid, 'res')
    elif choice == 2:
        es.cexec(userid, 'storm')
    elif choice == 3:
        es.cexec(userid, 'massheal')

def clericCastPrepHigh(userid, popupid):
    popup = popuplib.find('ClericcastHigh')
    Key = dnds.getPlayer(userid)
    level = dnds.getLevel(userid, 'Cleric')
    if level < 15:
        popup.modline(2, '')
    else:
        if Key['spells'][3] < 3:
            popup.modline(2, ' Ressurection')
        else:
            popup.modline(2, '-> 1. Ressurection')
    if level < 17:
        popup.modline(3, '')
    else:
        if Key['spells'][3] < 2:
            popup.modline(3, ' Fire Storm')
        else:
            popup.modline(3, '-> 2. Fire Storm')
    if level < 19:
        popup.modline(4, '')
    else:
        if Key['spells'][3] < 2:
            popup.modline(4, ' Mass Heal')
        else:
            popup.modline(4, '-> 3. Mass Heal')

def round_start(ev):
    for userid in es.getUseridList():
        ID = dnds.Bank(userid)
        if ID['race'] in ['Zombie', 'Skeleton', 'Shadow']:
            ID['race'] = 'Human'
            ID['class'] = 'Fighter'
            es.server.queuecmd('est_setplayercolor %s 255 255 255 255 1'%userid)
            es.server.queuecmd('est_spawn %s 1'%userid)

def round_end(ev):
    for userid in es.getUseridList():
        Key = dnds.getPlayer(userid)
        if Key['undead']:
            ID = dnds.Bank(userid)
            ID['race'] = Key['undead'][0]
            ID['class'] = Key['undead'][1]
            ID['prestige'] = Key['undead'][2]
