'''Drow race for D&D 3.5 Mod'''

import es, dnds, popuplib, random
from dnds import dnds

def load():
    dnds.addRace('Drow', levelAdjustment=2, bonusWeapons=['galil', 'famas'])
    
    drowinfo = popuplib.create('drowinformation')
    drowinfo.addline('-{ D&D CS:S - Drow Info }-')
    drowinfo.addline(' Level Adjustment - 2')
    drowinfo.addline(' Extra Weapons: Galil and Famas')
    drowinfo.addline(' Passive Skills:')
    drowinfo.addline(' - Drow Poison (Stun)')
    drowinfo.addline(' - Gain 5% Speed')
    drowinfo.addline(' - Spell Resistance')
    drowinfo.addline(' Commands:')
    drowinfo.addline(' - lev0 (Return Gravity)')
    drowinfo.addline(' - lev1 (Levitate 50% Gravity)')
    drowinfo.addline('-> 8. Back')
    drowinfo.addline('0. Exit')
    drowinfo.submenu(8, 'laracesinfo 1')
    dnds.addRaceInformation('Drow', 'drowinformation', levelAdjustment=2)

    for c in ['lev0', 'lev1']:
        dnds.Commands[c]['Races'].append('Drow')

def player_spawn(ev):
    userid = int(ev['userid'])
    if dnds.isRace(userid, 'Drow'):
        dnds.Speed(userid, .05)
        Key = dnds.getPlayer(userid)
        Key['spell resistance'] += 10

def player_hurt(ev):
    if ev['attacker'] and ev['attacker'] != '0':
        attacker = int(ev['attacker'])
        damage = int(float(ev['dmg_health']))
        if dnds.isRace(attacker, 'Drow'):
            if damage >= random.randint(1, 200):
                dnds.Stun(ev['userid'], 1)
                es.tell(attacker, '#multi', '#defaultYou have stunned %s with your Drow Poison'%es.getplayername(ev['userid']))
