'''A Fighter Prestige Class'''

import es, popuplib, dnds
from dnds import dnds

def load():
    dnds.addPrestigeClass('Exotic Weapons Master', 'Fighter', 5, dnds.Snipers)
    
    ewminfo = popuplib.create('ewminfo')
    ewminfo.addline('-{ D&D CS:S - Exotic Weapons Master Info }-')
    ewminfo.addline(' Required Level: 15')
    ewminfo.addline(' Lvl 1: Gain AWP')
    ewminfo.addline(' Lvl 2: Bonus Sniper Damage')
    ewminfo.addline(' Lvl 3: Auto Snipers')
    ewminfo.addline(' Lvl 5: Stunning Snipers')
    ewminfo.addline('-> 8. Back')
    ewminfo.addline('0. Exit')
    ewminfo.submenu(8, 'Fighterprestigeinfo 1')
    dnds.addPrestigeInformation('Exotic Weapons Master', 'ewminfo')
    
def player_spawn(ev):
    userid = int(ev['userid'])
    Key = dnds.getPlayer(userid)
    if dnds.isPrestige(userid, 'Exotic Weapons Master'):
        level = dnds.getLevel(userid, 'Exotic Weapons Master')
        if level >= 1:
            Key['extra weapons'].append('awp')
        if level >= 3:
            Key['extra weapons'].append('sg550')
            Key['extra weapons'].append('g3sg1')

def player_hurt(ev):
    attacker = int(ev['attacker'])
    userid = int(ev['userid'])
    damage = int(float(ev['dmg_health']))
    if attacker:
        if dnds.isPrestige(attacker, 'Exotic Weapons Master'):
            level = dnds.getLevel(attacker, 'Exotic Weapons Master')
            if level >= 2:
                dnds.Damage(userid, attacker, damage*.2)
            if level >= 5:
                dnds.Stun(userid, damage/15)
