'''A Basic Monster Race for D&D CSS'''

import es, dnds, popuplib
from dnds import dnds

def load():
    dnds.addRace('Half Troll', monsterRace=True, bpRequired=0, bonusWeapons=dnds.Pistols+dnds.ShotGuns+['knife'])
    
    halftrollinfo = popuplib.create('halftrollinfo')
    halftrollinfo.addline('-{ D&D CS:S - Half Troll Info }-')
    halftrollinfo.addline(' Required Bonus Points: 0')
    halftrollinfo.addline(' Weapons: Pistols and Shotguns ')
    halftrollinfo.addline(' Powers: ')
    halftrollinfo.addline('  Regeneration ')
    halftrollinfo.addline('  +20% Damage ')
    halftrollinfo.addline('  +25 Health ')
    halftrollinfo.addline('-> 8. Back')
    halftrollinfo.addline('0. Exit')
    halftrollinfo.submenu(8, 'monracesinfo 1')
    dnds.addRaceInformation('Half Troll', 'halftrollinfo', monsterRace=True, bpRequired=0)

def player_spawn(ev):
    userid = int(ev['userid'])
    if dnds.isRace(userid, 'Half Troll'):
        dnds.Health(userid, 25)
        dnds.Regeneration(userid, 1, 2)

def player_hurt(ev):
    if ev['attacker'] and ev['attacker'] != '0':
        attacker = int(ev['attacker'])
        damage = int(float(ev['dmg_health']))
        if dnds.isRace(attacker, 'Half Troll'):
            dnds.Damage(ev['userid'], attacker, damage*.2)
